// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: complex_data_types.proto

#include "complex_data_types.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class ListOfBoolsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ListOfBools>
      _instance;
} _ListOfBools_default_instance_;
class ListOfIntsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ListOfInts>
      _instance;
} _ListOfInts_default_instance_;
class ListOfDoublesDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ListOfDoubles>
      _instance;
} _ListOfDoubles_default_instance_;
class ListOfStringsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<ListOfStrings>
      _instance;
} _ListOfStrings_default_instance_;
class MatrixOfBoolsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MatrixOfBools>
      _instance;
} _MatrixOfBools_default_instance_;
class MatrixOfIntsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MatrixOfInts>
      _instance;
} _MatrixOfInts_default_instance_;
class MatrixOfDoublesDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MatrixOfDoubles>
      _instance;
} _MatrixOfDoubles_default_instance_;
class MatrixOfStringsDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<MatrixOfStrings>
      _instance;
} _MatrixOfStrings_default_instance_;
}  // namespace mascot
namespace protobuf_complex_5fdata_5ftypes_2eproto {
void InitDefaultsListOfBoolsImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_ListOfBools_default_instance_;
    new (ptr) ::mascot::ListOfBools();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ListOfBools::InitAsDefaultInstance();
}

void InitDefaultsListOfBools() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsListOfBoolsImpl);
}

void InitDefaultsListOfIntsImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_ListOfInts_default_instance_;
    new (ptr) ::mascot::ListOfInts();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ListOfInts::InitAsDefaultInstance();
}

void InitDefaultsListOfInts() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsListOfIntsImpl);
}

void InitDefaultsListOfDoublesImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_ListOfDoubles_default_instance_;
    new (ptr) ::mascot::ListOfDoubles();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ListOfDoubles::InitAsDefaultInstance();
}

void InitDefaultsListOfDoubles() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsListOfDoublesImpl);
}

void InitDefaultsListOfStringsImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_ListOfStrings_default_instance_;
    new (ptr) ::mascot::ListOfStrings();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::ListOfStrings::InitAsDefaultInstance();
}

void InitDefaultsListOfStrings() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsListOfStringsImpl);
}

void InitDefaultsMatrixOfBoolsImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfBools();
  {
    void* ptr = &::mascot::_MatrixOfBools_default_instance_;
    new (ptr) ::mascot::MatrixOfBools();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::MatrixOfBools::InitAsDefaultInstance();
}

void InitDefaultsMatrixOfBools() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsMatrixOfBoolsImpl);
}

void InitDefaultsMatrixOfIntsImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfInts();
  {
    void* ptr = &::mascot::_MatrixOfInts_default_instance_;
    new (ptr) ::mascot::MatrixOfInts();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::MatrixOfInts::InitAsDefaultInstance();
}

void InitDefaultsMatrixOfInts() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsMatrixOfIntsImpl);
}

void InitDefaultsMatrixOfDoublesImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfDoubles();
  {
    void* ptr = &::mascot::_MatrixOfDoubles_default_instance_;
    new (ptr) ::mascot::MatrixOfDoubles();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::MatrixOfDoubles::InitAsDefaultInstance();
}

void InitDefaultsMatrixOfDoubles() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsMatrixOfDoublesImpl);
}

void InitDefaultsMatrixOfStringsImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfStrings();
  {
    void* ptr = &::mascot::_MatrixOfStrings_default_instance_;
    new (ptr) ::mascot::MatrixOfStrings();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::MatrixOfStrings::InitAsDefaultInstance();
}

void InitDefaultsMatrixOfStrings() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsMatrixOfStringsImpl);
}

::google::protobuf::Metadata file_level_metadata[8];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfBools, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfBools, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfInts, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfInts, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfDoubles, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfDoubles, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfStrings, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::ListOfStrings, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfBools, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfBools, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfInts, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfInts, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfDoubles, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfDoubles, value_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfStrings, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::MatrixOfStrings, value_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::ListOfBools)},
  { 6, -1, sizeof(::mascot::ListOfInts)},
  { 12, -1, sizeof(::mascot::ListOfDoubles)},
  { 18, -1, sizeof(::mascot::ListOfStrings)},
  { 24, -1, sizeof(::mascot::MatrixOfBools)},
  { 30, -1, sizeof(::mascot::MatrixOfInts)},
  { 36, -1, sizeof(::mascot::MatrixOfDoubles)},
  { 42, -1, sizeof(::mascot::MatrixOfStrings)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_ListOfBools_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_ListOfInts_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_ListOfDoubles_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_ListOfStrings_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_MatrixOfBools_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_MatrixOfInts_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_MatrixOfDoubles_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_MatrixOfStrings_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "complex_data_types.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 8);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\030complex_data_types.proto\022\006mascot\"\034\n\013Li"
      "stOfBools\022\r\n\005value\030\001 \003(\010\"\033\n\nListOfInts\022\r"
      "\n\005value\030\001 \003(\003\"\036\n\rListOfDoubles\022\r\n\005value\030"
      "\001 \003(\001\"\036\n\rListOfStrings\022\r\n\005value\030\001 \003(\t\"3\n"
      "\rMatrixOfBools\022\"\n\005value\030\001 \003(\0132\023.mascot.L"
      "istOfBools\"1\n\014MatrixOfInts\022!\n\005value\030\001 \003("
      "\0132\022.mascot.ListOfInts\"7\n\017MatrixOfDoubles"
      "\022$\n\005value\030\001 \003(\0132\025.mascot.ListOfDoubles\"7"
      "\n\017MatrixOfStrings\022$\n\005value\030\001 \003(\0132\025.masco"
      "t.ListOfStringsb\006proto3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 383);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "complex_data_types.proto", &protobuf_RegisterTypes);
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_complex_5fdata_5ftypes_2eproto
namespace mascot {

// ===================================================================

void ListOfBools::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ListOfBools::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ListOfBools::ListOfBools()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfBools();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.ListOfBools)
}
ListOfBools::ListOfBools(const ListOfBools& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.ListOfBools)
}

void ListOfBools::SharedCtor() {
  _cached_size_ = 0;
}

ListOfBools::~ListOfBools() {
  // @@protoc_insertion_point(destructor:mascot.ListOfBools)
  SharedDtor();
}

void ListOfBools::SharedDtor() {
}

void ListOfBools::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* ListOfBools::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const ListOfBools& ListOfBools::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfBools();
  return *internal_default_instance();
}

ListOfBools* ListOfBools::New(::google::protobuf::Arena* arena) const {
  ListOfBools* n = new ListOfBools;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void ListOfBools::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ListOfBools)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool ListOfBools::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.ListOfBools)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated bool value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, this->mutable_value())));
        } else if (
            static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 1, 10u, input, this->mutable_value())));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.ListOfBools)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.ListOfBools)
  return false;
#undef DO_
}

void ListOfBools::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.ListOfBools)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated bool value = 1;
  if (this->value_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(1, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(static_cast< ::google::protobuf::uint32>(
        _value_cached_byte_size_));
    ::google::protobuf::internal::WireFormatLite::WriteBoolArray(
      this->value().data(), this->value_size(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.ListOfBools)
}

::google::protobuf::uint8* ListOfBools::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ListOfBools)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated bool value = 1;
  if (this->value_size() > 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteTagToArray(
      1,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      target);
    target = ::google::protobuf::io::CodedOutputStream::WriteVarint32ToArray(
        static_cast< ::google::protobuf::int32>(
            _value_cached_byte_size_), target);
    target = ::google::protobuf::internal::WireFormatLite::
      WriteBoolNoTagToArray(this->value_, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ListOfBools)
  return target;
}

size_t ListOfBools::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ListOfBools)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated bool value = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->value_size());
    size_t data_size = 1UL * count;
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
            static_cast< ::google::protobuf::int32>(data_size));
    }
    int cached_size = ::google::protobuf::internal::ToCachedSize(data_size);
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _value_cached_byte_size_ = cached_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void ListOfBools::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ListOfBools)
  GOOGLE_DCHECK_NE(&from, this);
  const ListOfBools* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const ListOfBools>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ListOfBools)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ListOfBools)
    MergeFrom(*source);
  }
}

void ListOfBools::MergeFrom(const ListOfBools& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ListOfBools)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void ListOfBools::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ListOfBools)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ListOfBools::CopyFrom(const ListOfBools& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ListOfBools)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ListOfBools::IsInitialized() const {
  return true;
}

void ListOfBools::Swap(ListOfBools* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ListOfBools::InternalSwap(ListOfBools* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata ListOfBools::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void ListOfInts::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ListOfInts::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ListOfInts::ListOfInts()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfInts();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.ListOfInts)
}
ListOfInts::ListOfInts(const ListOfInts& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.ListOfInts)
}

void ListOfInts::SharedCtor() {
  _cached_size_ = 0;
}

ListOfInts::~ListOfInts() {
  // @@protoc_insertion_point(destructor:mascot.ListOfInts)
  SharedDtor();
}

void ListOfInts::SharedDtor() {
}

void ListOfInts::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* ListOfInts::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const ListOfInts& ListOfInts::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfInts();
  return *internal_default_instance();
}

ListOfInts* ListOfInts::New(::google::protobuf::Arena* arena) const {
  ListOfInts* n = new ListOfInts;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void ListOfInts::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ListOfInts)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool ListOfInts::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.ListOfInts)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated int64 value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, this->mutable_value())));
        } else if (
            static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 1, 10u, input, this->mutable_value())));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.ListOfInts)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.ListOfInts)
  return false;
#undef DO_
}

void ListOfInts::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.ListOfInts)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated int64 value = 1;
  if (this->value_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(1, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(static_cast< ::google::protobuf::uint32>(
        _value_cached_byte_size_));
  }
  for (int i = 0, n = this->value_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64NoTag(
      this->value(i), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.ListOfInts)
}

::google::protobuf::uint8* ListOfInts::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ListOfInts)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated int64 value = 1;
  if (this->value_size() > 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteTagToArray(
      1,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      target);
    target = ::google::protobuf::io::CodedOutputStream::WriteVarint32ToArray(
        static_cast< ::google::protobuf::int32>(
            _value_cached_byte_size_), target);
    target = ::google::protobuf::internal::WireFormatLite::
      WriteInt64NoTagToArray(this->value_, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ListOfInts)
  return target;
}

size_t ListOfInts::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ListOfInts)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated int64 value = 1;
  {
    size_t data_size = ::google::protobuf::internal::WireFormatLite::
      Int64Size(this->value_);
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
            static_cast< ::google::protobuf::int32>(data_size));
    }
    int cached_size = ::google::protobuf::internal::ToCachedSize(data_size);
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _value_cached_byte_size_ = cached_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void ListOfInts::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ListOfInts)
  GOOGLE_DCHECK_NE(&from, this);
  const ListOfInts* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const ListOfInts>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ListOfInts)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ListOfInts)
    MergeFrom(*source);
  }
}

void ListOfInts::MergeFrom(const ListOfInts& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ListOfInts)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void ListOfInts::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ListOfInts)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ListOfInts::CopyFrom(const ListOfInts& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ListOfInts)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ListOfInts::IsInitialized() const {
  return true;
}

void ListOfInts::Swap(ListOfInts* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ListOfInts::InternalSwap(ListOfInts* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata ListOfInts::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void ListOfDoubles::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ListOfDoubles::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ListOfDoubles::ListOfDoubles()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfDoubles();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.ListOfDoubles)
}
ListOfDoubles::ListOfDoubles(const ListOfDoubles& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.ListOfDoubles)
}

void ListOfDoubles::SharedCtor() {
  _cached_size_ = 0;
}

ListOfDoubles::~ListOfDoubles() {
  // @@protoc_insertion_point(destructor:mascot.ListOfDoubles)
  SharedDtor();
}

void ListOfDoubles::SharedDtor() {
}

void ListOfDoubles::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* ListOfDoubles::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const ListOfDoubles& ListOfDoubles::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfDoubles();
  return *internal_default_instance();
}

ListOfDoubles* ListOfDoubles::New(::google::protobuf::Arena* arena) const {
  ListOfDoubles* n = new ListOfDoubles;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void ListOfDoubles::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ListOfDoubles)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool ListOfDoubles::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.ListOfDoubles)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated double value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadPackedPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, this->mutable_value())));
        } else if (
            static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(9u /* 9 & 0xFF */)) {
          DO_((::google::protobuf::internal::WireFormatLite::ReadRepeatedPrimitiveNoInline<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 1, 10u, input, this->mutable_value())));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.ListOfDoubles)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.ListOfDoubles)
  return false;
#undef DO_
}

void ListOfDoubles::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.ListOfDoubles)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated double value = 1;
  if (this->value_size() > 0) {
    ::google::protobuf::internal::WireFormatLite::WriteTag(1, ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED, output);
    output->WriteVarint32(static_cast< ::google::protobuf::uint32>(
        _value_cached_byte_size_));
    ::google::protobuf::internal::WireFormatLite::WriteDoubleArray(
      this->value().data(), this->value_size(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.ListOfDoubles)
}

::google::protobuf::uint8* ListOfDoubles::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ListOfDoubles)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated double value = 1;
  if (this->value_size() > 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteTagToArray(
      1,
      ::google::protobuf::internal::WireFormatLite::WIRETYPE_LENGTH_DELIMITED,
      target);
    target = ::google::protobuf::io::CodedOutputStream::WriteVarint32ToArray(
        static_cast< ::google::protobuf::int32>(
            _value_cached_byte_size_), target);
    target = ::google::protobuf::internal::WireFormatLite::
      WriteDoubleNoTagToArray(this->value_, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ListOfDoubles)
  return target;
}

size_t ListOfDoubles::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ListOfDoubles)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated double value = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->value_size());
    size_t data_size = 8UL * count;
    if (data_size > 0) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int32Size(
            static_cast< ::google::protobuf::int32>(data_size));
    }
    int cached_size = ::google::protobuf::internal::ToCachedSize(data_size);
    GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
    _value_cached_byte_size_ = cached_size;
    GOOGLE_SAFE_CONCURRENT_WRITES_END();
    total_size += data_size;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void ListOfDoubles::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ListOfDoubles)
  GOOGLE_DCHECK_NE(&from, this);
  const ListOfDoubles* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const ListOfDoubles>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ListOfDoubles)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ListOfDoubles)
    MergeFrom(*source);
  }
}

void ListOfDoubles::MergeFrom(const ListOfDoubles& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ListOfDoubles)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void ListOfDoubles::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ListOfDoubles)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ListOfDoubles::CopyFrom(const ListOfDoubles& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ListOfDoubles)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ListOfDoubles::IsInitialized() const {
  return true;
}

void ListOfDoubles::Swap(ListOfDoubles* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ListOfDoubles::InternalSwap(ListOfDoubles* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata ListOfDoubles::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void ListOfStrings::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int ListOfStrings::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

ListOfStrings::ListOfStrings()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfStrings();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.ListOfStrings)
}
ListOfStrings::ListOfStrings(const ListOfStrings& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.ListOfStrings)
}

void ListOfStrings::SharedCtor() {
  _cached_size_ = 0;
}

ListOfStrings::~ListOfStrings() {
  // @@protoc_insertion_point(destructor:mascot.ListOfStrings)
  SharedDtor();
}

void ListOfStrings::SharedDtor() {
}

void ListOfStrings::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* ListOfStrings::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const ListOfStrings& ListOfStrings::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfStrings();
  return *internal_default_instance();
}

ListOfStrings* ListOfStrings::New(::google::protobuf::Arena* arena) const {
  ListOfStrings* n = new ListOfStrings;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void ListOfStrings::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.ListOfStrings)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool ListOfStrings::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.ListOfStrings)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated string value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->add_value()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->value(this->value_size() - 1).data(),
            static_cast<int>(this->value(this->value_size() - 1).length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.ListOfStrings.value"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.ListOfStrings)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.ListOfStrings)
  return false;
#undef DO_
}

void ListOfStrings::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.ListOfStrings)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated string value = 1;
  for (int i = 0, n = this->value_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->value(i).data(), static_cast<int>(this->value(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ListOfStrings.value");
    ::google::protobuf::internal::WireFormatLite::WriteString(
      1, this->value(i), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.ListOfStrings)
}

::google::protobuf::uint8* ListOfStrings::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.ListOfStrings)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated string value = 1;
  for (int i = 0, n = this->value_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->value(i).data(), static_cast<int>(this->value(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.ListOfStrings.value");
    target = ::google::protobuf::internal::WireFormatLite::
      WriteStringToArray(1, this->value(i), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.ListOfStrings)
  return target;
}

size_t ListOfStrings::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.ListOfStrings)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated string value = 1;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->value_size());
  for (int i = 0, n = this->value_size(); i < n; i++) {
    total_size += ::google::protobuf::internal::WireFormatLite::StringSize(
      this->value(i));
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void ListOfStrings::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.ListOfStrings)
  GOOGLE_DCHECK_NE(&from, this);
  const ListOfStrings* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const ListOfStrings>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.ListOfStrings)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.ListOfStrings)
    MergeFrom(*source);
  }
}

void ListOfStrings::MergeFrom(const ListOfStrings& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.ListOfStrings)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void ListOfStrings::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.ListOfStrings)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void ListOfStrings::CopyFrom(const ListOfStrings& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.ListOfStrings)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool ListOfStrings::IsInitialized() const {
  return true;
}

void ListOfStrings::Swap(ListOfStrings* other) {
  if (other == this) return;
  InternalSwap(other);
}
void ListOfStrings::InternalSwap(ListOfStrings* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata ListOfStrings::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void MatrixOfBools::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MatrixOfBools::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MatrixOfBools::MatrixOfBools()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfBools();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.MatrixOfBools)
}
MatrixOfBools::MatrixOfBools(const MatrixOfBools& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.MatrixOfBools)
}

void MatrixOfBools::SharedCtor() {
  _cached_size_ = 0;
}

MatrixOfBools::~MatrixOfBools() {
  // @@protoc_insertion_point(destructor:mascot.MatrixOfBools)
  SharedDtor();
}

void MatrixOfBools::SharedDtor() {
}

void MatrixOfBools::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* MatrixOfBools::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const MatrixOfBools& MatrixOfBools::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfBools();
  return *internal_default_instance();
}

MatrixOfBools* MatrixOfBools::New(::google::protobuf::Arena* arena) const {
  MatrixOfBools* n = new MatrixOfBools;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void MatrixOfBools::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.MatrixOfBools)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool MatrixOfBools::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.MatrixOfBools)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.ListOfBools value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_value()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.MatrixOfBools)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.MatrixOfBools)
  return false;
#undef DO_
}

void MatrixOfBools::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.MatrixOfBools)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfBools value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->value(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.MatrixOfBools)
}

::google::protobuf::uint8* MatrixOfBools::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.MatrixOfBools)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfBools value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->value(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.MatrixOfBools)
  return target;
}

size_t MatrixOfBools::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.MatrixOfBools)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.ListOfBools value = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->value_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->value(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void MatrixOfBools::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.MatrixOfBools)
  GOOGLE_DCHECK_NE(&from, this);
  const MatrixOfBools* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const MatrixOfBools>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.MatrixOfBools)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.MatrixOfBools)
    MergeFrom(*source);
  }
}

void MatrixOfBools::MergeFrom(const MatrixOfBools& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.MatrixOfBools)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void MatrixOfBools::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.MatrixOfBools)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void MatrixOfBools::CopyFrom(const MatrixOfBools& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.MatrixOfBools)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MatrixOfBools::IsInitialized() const {
  return true;
}

void MatrixOfBools::Swap(MatrixOfBools* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MatrixOfBools::InternalSwap(MatrixOfBools* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata MatrixOfBools::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void MatrixOfInts::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MatrixOfInts::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MatrixOfInts::MatrixOfInts()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfInts();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.MatrixOfInts)
}
MatrixOfInts::MatrixOfInts(const MatrixOfInts& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.MatrixOfInts)
}

void MatrixOfInts::SharedCtor() {
  _cached_size_ = 0;
}

MatrixOfInts::~MatrixOfInts() {
  // @@protoc_insertion_point(destructor:mascot.MatrixOfInts)
  SharedDtor();
}

void MatrixOfInts::SharedDtor() {
}

void MatrixOfInts::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* MatrixOfInts::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const MatrixOfInts& MatrixOfInts::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfInts();
  return *internal_default_instance();
}

MatrixOfInts* MatrixOfInts::New(::google::protobuf::Arena* arena) const {
  MatrixOfInts* n = new MatrixOfInts;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void MatrixOfInts::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.MatrixOfInts)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool MatrixOfInts::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.MatrixOfInts)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.ListOfInts value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_value()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.MatrixOfInts)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.MatrixOfInts)
  return false;
#undef DO_
}

void MatrixOfInts::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.MatrixOfInts)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfInts value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->value(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.MatrixOfInts)
}

::google::protobuf::uint8* MatrixOfInts::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.MatrixOfInts)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfInts value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->value(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.MatrixOfInts)
  return target;
}

size_t MatrixOfInts::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.MatrixOfInts)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.ListOfInts value = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->value_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->value(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void MatrixOfInts::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.MatrixOfInts)
  GOOGLE_DCHECK_NE(&from, this);
  const MatrixOfInts* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const MatrixOfInts>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.MatrixOfInts)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.MatrixOfInts)
    MergeFrom(*source);
  }
}

void MatrixOfInts::MergeFrom(const MatrixOfInts& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.MatrixOfInts)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void MatrixOfInts::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.MatrixOfInts)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void MatrixOfInts::CopyFrom(const MatrixOfInts& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.MatrixOfInts)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MatrixOfInts::IsInitialized() const {
  return true;
}

void MatrixOfInts::Swap(MatrixOfInts* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MatrixOfInts::InternalSwap(MatrixOfInts* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata MatrixOfInts::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void MatrixOfDoubles::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MatrixOfDoubles::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MatrixOfDoubles::MatrixOfDoubles()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfDoubles();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.MatrixOfDoubles)
}
MatrixOfDoubles::MatrixOfDoubles(const MatrixOfDoubles& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.MatrixOfDoubles)
}

void MatrixOfDoubles::SharedCtor() {
  _cached_size_ = 0;
}

MatrixOfDoubles::~MatrixOfDoubles() {
  // @@protoc_insertion_point(destructor:mascot.MatrixOfDoubles)
  SharedDtor();
}

void MatrixOfDoubles::SharedDtor() {
}

void MatrixOfDoubles::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* MatrixOfDoubles::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const MatrixOfDoubles& MatrixOfDoubles::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfDoubles();
  return *internal_default_instance();
}

MatrixOfDoubles* MatrixOfDoubles::New(::google::protobuf::Arena* arena) const {
  MatrixOfDoubles* n = new MatrixOfDoubles;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void MatrixOfDoubles::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.MatrixOfDoubles)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool MatrixOfDoubles::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.MatrixOfDoubles)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.ListOfDoubles value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_value()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.MatrixOfDoubles)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.MatrixOfDoubles)
  return false;
#undef DO_
}

void MatrixOfDoubles::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.MatrixOfDoubles)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfDoubles value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->value(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.MatrixOfDoubles)
}

::google::protobuf::uint8* MatrixOfDoubles::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.MatrixOfDoubles)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfDoubles value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->value(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.MatrixOfDoubles)
  return target;
}

size_t MatrixOfDoubles::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.MatrixOfDoubles)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.ListOfDoubles value = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->value_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->value(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void MatrixOfDoubles::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.MatrixOfDoubles)
  GOOGLE_DCHECK_NE(&from, this);
  const MatrixOfDoubles* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const MatrixOfDoubles>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.MatrixOfDoubles)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.MatrixOfDoubles)
    MergeFrom(*source);
  }
}

void MatrixOfDoubles::MergeFrom(const MatrixOfDoubles& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.MatrixOfDoubles)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void MatrixOfDoubles::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.MatrixOfDoubles)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void MatrixOfDoubles::CopyFrom(const MatrixOfDoubles& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.MatrixOfDoubles)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MatrixOfDoubles::IsInitialized() const {
  return true;
}

void MatrixOfDoubles::Swap(MatrixOfDoubles* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MatrixOfDoubles::InternalSwap(MatrixOfDoubles* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata MatrixOfDoubles::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void MatrixOfStrings::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int MatrixOfStrings::kValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

MatrixOfStrings::MatrixOfStrings()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfStrings();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.MatrixOfStrings)
}
MatrixOfStrings::MatrixOfStrings(const MatrixOfStrings& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      value_(from.value_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.MatrixOfStrings)
}

void MatrixOfStrings::SharedCtor() {
  _cached_size_ = 0;
}

MatrixOfStrings::~MatrixOfStrings() {
  // @@protoc_insertion_point(destructor:mascot.MatrixOfStrings)
  SharedDtor();
}

void MatrixOfStrings::SharedDtor() {
}

void MatrixOfStrings::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* MatrixOfStrings::descriptor() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const MatrixOfStrings& MatrixOfStrings::default_instance() {
  ::protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfStrings();
  return *internal_default_instance();
}

MatrixOfStrings* MatrixOfStrings::New(::google::protobuf::Arena* arena) const {
  MatrixOfStrings* n = new MatrixOfStrings;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void MatrixOfStrings::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.MatrixOfStrings)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  value_.Clear();
  _internal_metadata_.Clear();
}

bool MatrixOfStrings::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.MatrixOfStrings)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.ListOfStrings value = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_value()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.MatrixOfStrings)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.MatrixOfStrings)
  return false;
#undef DO_
}

void MatrixOfStrings::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.MatrixOfStrings)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfStrings value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->value(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.MatrixOfStrings)
}

::google::protobuf::uint8* MatrixOfStrings::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.MatrixOfStrings)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.ListOfStrings value = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->value_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->value(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.MatrixOfStrings)
  return target;
}

size_t MatrixOfStrings::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.MatrixOfStrings)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.ListOfStrings value = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->value_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->value(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void MatrixOfStrings::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.MatrixOfStrings)
  GOOGLE_DCHECK_NE(&from, this);
  const MatrixOfStrings* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const MatrixOfStrings>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.MatrixOfStrings)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.MatrixOfStrings)
    MergeFrom(*source);
  }
}

void MatrixOfStrings::MergeFrom(const MatrixOfStrings& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.MatrixOfStrings)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  value_.MergeFrom(from.value_);
}

void MatrixOfStrings::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.MatrixOfStrings)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void MatrixOfStrings::CopyFrom(const MatrixOfStrings& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.MatrixOfStrings)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool MatrixOfStrings::IsInitialized() const {
  return true;
}

void MatrixOfStrings::Swap(MatrixOfStrings* other) {
  if (other == this) return;
  InternalSwap(other);
}
void MatrixOfStrings::InternalSwap(MatrixOfStrings* other) {
  using std::swap;
  value_.InternalSwap(&other->value_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata MatrixOfStrings::GetMetadata() const {
  protobuf_complex_5fdata_5ftypes_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_complex_5fdata_5ftypes_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
